unit Unit6;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Discord_game_sdk,
  Vcl.ExtCtrls;

type
  TForm6 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private-Deklarationen }
    IDiscordCoreEvents: PPIDiscordCoreEvents;
    FActivityManager_Link: PIDiscordActivityManager;
  public
    { Public-Deklarationen }
  end;

var
  Form6: TForm6;

implementation

{$R *.dfm}

procedure testcb(callback_data: pointer; reslt: TEDiscordResult); cdecl;
begin
  TMemo(callback_data).Lines.Add('testcb Result = ' + inttostr(ord(reslt)));
end;

procedure LogMessage(hook_data: pointer; level: TEDiscordLogLevel; message_: PAnsiChar); cdecl;
begin
  TMemo(hook_data).Lines.Add(#13#10+'Log Entry ('+inttostr(ord(level))+'): ' + message_+#13#10);
end;





procedure TForm6.Button1Click(Sender: TObject);
var
  _res: integer;
  activity: TDiscordActivity;
  ptr: pointer;
begin
  Timer1.Enabled := true;

  _res := ord(DiscordInit(123456789123456789));    //Enter here your Discord application ID for your game, the place to set this up is linked in the Discord SDK documentation
  Memo1.Lines.Add('DiscordCreate Result = ' + inttostr(_res));

  Discord.Core.set_log_hook(Discord.Core, {DiscordLogLevel_Error} DiscordLogLevel_Debug, Memo1, LogMessage);

  FActivityManager_Link := Discord.Core.get_activity_manager(Discord.Core);
  Memo1.Lines.Add('FActivityManager_Link = ' + inttostr(int64(FActivityManager_Link)));

  _res := ord(FActivityManager_Link.register_steam(FActivityManager_Link, 123456)); //add your Steam ID here (the Steam ID of your game!)
  Memo1.Lines.Add('register_steam Result = ' + inttostr(_res));

  with activity do
  begin
    typ := DiscordActivityType_Playing;
    application_id := 123456789123456789;     //the App ID mentioned above
    name := 'Testname';
    state := 'TestState';
    details := 'TestDetails';
    timestamps.start := 60;                  //yet i have NO CLUE how those work
    timestamps.ende := 0;                    //yet i have NO CLUE how those work
    assets.large_image := 'wasistdas1';
    assets.large_text := 'wasistdas2';
    assets.small_image := 'wasistdas3';
    assets.small_text := 'wasistdas4';
    party.id := '113';
    party.size.current_size := 2;
    party.size.max_size := 50;
    secrets.match := '123';
    secrets.join := '234';
    secrets.spectate := '345';
    instance := true;
  end;
  ptr := Memo1;
  FActivityManager_Link.update_activity(FActivityManager_Link, @activity, ptr, testcb);
end;

procedure TForm6.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  Timer1.Enabled := false;
  DiscordFinalize;
end;

procedure TForm6.Timer1Timer(Sender: TObject);
var
  _res: integer;
begin
  _res := ord(Discord.Core.run_callbacks(Discord.Core));
  if _res<>0 then
    Memo1.Lines.Add('RunCallBacks Result = ' + inttostr(_res));
end;

end.
